c---------------------------------------------------------------------c
c                                                                     c
c    Programma per la soluzione dell'equazione integrodifferenziale   c
c    del trasporto in geometria cartesiana 3D                         c
c                                                                     c
c    Questo programma  stato messo a punto per scopi didattici       c
c    e non  stato sottoposto ad un processo di convalida             c
c    sufficientemente accurato da garantire la correttezza            c
c    quantitativa dei suoi risultati.                                 c
c                                                                     c
c    W. Ambrosini, DIMNP, Dicembre 2000                               c
c                                                                     c 
c---------------------------------------------------------------------c
      program tras3d
      implicit double precision (a-h,o-z)
c
      include 'tras3dc.for'
c
      open (unit=5,file='tras3d.dat')
      open (unit=6,file='tras3d.out')
      open (unit=7,file='tras3d.ord')
	open (unit=8,file='trasxy.txt')
	open (unit=9,file='trasxz.txt')
	open (unit=10,file='trasyz.txt')
	open (unit=11,file='trasxy1.txt')
	open (unit=12,file='trasxz1.txt')
	open (unit=13,file='trasyz1.txt')
	open (unit=14,file='trasxy2.txt')
	open (unit=15,file='trasxz2.txt')
	open (unit=16,file='trasyz2.txt')
c
c   Calcolo di pi greca
c
      pi = 4.d00 * datan (1.d00)
c
c   Lettura del numero di strati lungo gli assi x ed y e del numero di ordinate
c
      read (5,*)
	read (5,*) nlax,nlay,nlaz,nordin
c
c   Lettura dello spessore e del numero di nodi in ciascuno strato x
c   e assegnazione delle coordinate dei nodi e delle interfacce lungo x
c
      read (5,*)
c
      x(1) = 0.d00
	i = 1
c
	  do ilax = 1,nlax
	  read (5,*) deltx,nlx
        dx = deltx / dfloat (nlx)
c
           do ix = 1,nlx
           i = i + 1
	     x(i) = x(i-1) + dx
	     xm(i-1) = x(i-1) + 0.5d00 * dx
           enddo
c
        enddo
c
      nx = i - 1
c
c   Lettura dello spessore e del numero di nodi in ciascuno strato y
c   e assegnazione delle coordinate dei nodi e delle interfacce lungo y
c
      read (5,*)
c
      y(1) = 0.d00
	j = 1
c
	  do ilay = 1,nlay
	  read (5,*) delty,nly
        dy = delty / dfloat (nly)
c
           do iy = 1,nly
           j = j + 1
	     y(j) = y(j-1) + dy
	     ym(j-1) = y(j-1) + 0.5d00 * dy
           enddo
c
        enddo
c
      ny = j - 1
c
c   Lettura dello spessore e del numero di nodi in ciascuno strato z
c   e assegnazione delle coordinate dei nodi e delle interfacce lungo z
c
      read (5,*)
c
      z(1) = 0.d00
	k = 1
c
	  do ilaz = 1,nlaz
	  read (5,*) deltz,nlz
        dz = deltz / dfloat (nlz)
c
           do iz = 1,nlz
           k = k + 1
	     z(k) = z(k-1) + dz
	     zm(k-1) = z(k-1) + 0.5d00 * dz
           enddo
c
        enddo
c
      nz = k - 1
c	     
c   Lettura ed assegnazione delle sezioni d'urto e della sorgente generali
c
      read (5,*)
	read (5,*) sigmat,sigmas,sourt
c
        do i = 1,nx
	   do j = 1,ny
 	    do k = 1,nz
	     sigt(i,j,k) = sigmat
	     sigs(i,j,k) = sigmas
	     sour(i,j,k) = sourt
	    enddo
	   enddo
	  enddo
c
c   Lettura del numero e della posizione delle regioni con propriet diverse
c   da quelle generali (ridefinizione dei valori nei singoli nodi)
c
      read (5,*)
	read (5,*) nreg
c
      read (5,*)
      read (5,*)
c
	   do ir = 1,nreg
	   read (5,*) x1,x2,y1,y2,z1,z2,sigmat,sigmas,sval       
c
           if(x2.gt.0.d00) then
            do i = 1,nx
		   do j = 1,ny
		    do k = 1,nz
	  		 if( (xm(i).ge.x1).and.(xm(i).le.x2)
     &	         .and.(ym(j).ge.y1).and.(ym(j).le.y2)
     &             .and.(zm(k).ge.z1).and.(zm(k).le.z2) ) then
	         sour(i,j,k) = sval
  	         sigt(i,j,k) = sigmat
	         sigs(i,j,k) = sigmas
	         endif
              enddo
	       enddo
	      enddo
c
           else
           radius = dabs ( x2 )
c
            do i = 1,nx
  	      distx = xm(i) - x1
c
		   do j = 1,ny
	       disty = ym(j) - y1
	       rad = dsqrt ( distx * distx + disty * disty )
c
		    do k = 1,nz
	  		 if( (rad.le.radius)
     &             .and.(zm(k).ge.z1).and.(zm(k).le.z2) ) then
	         sour(i,j,k) = sval
  	         sigt(i,j,k) = sigmat
	         sigs(i,j,k) = sigmas
	         endif
              enddo
	       enddo
	      enddo
c
	     endif
c
	   enddo
c
c   Lettura dei flussi entranti sulle sei facce del parallelepipedo
c
      read (5,*)
      read (5,*)
	read (5,*) phiawf,phiaef,phiasf,phianf,phiabf,phiatf
c
c   Definizione dell'errore massimo errore sul flusso tra due iterazioni successive
c
      read (5,*)
	read (5,*) epsphi
c
c   Assegnazione delle ordinate discrete e dei relativi pesi
c
      call diradm
c
c  Assegnazione del valore iniziale della densit di emissione e del valore dei flussi
c  all'iterazione precedente (oldphi)
c
        do i = 1,nx
	   do j = 1,ny
 	    do k = 1,nz
	     q(i,j,k) = sour(i,j,k)
c
	     oldphi(i,j,k) = 0.d00
c
	    enddo
	   enddo
	  enddo
c
        do im = 1,nm
c
         do j = 1,ny
          do k = 1,nz
          phiaem(j,k,im) = dabs (phiaef)
          phiawm(j,k,im) = dabs (phiawf)
	    enddo
	   enddo
c
         do i = 1,nx
          do k = 1,nz
          phiasm(i,k,im) = dabs (phiasf)
          phianm(i,k,im) = dabs (phianf)
	    enddo
	   enddo
c
         do i = 1,nx
          do j = 1,ny
          phiabm(i,j,im) = dabs (phiabf)
          phiatm(i,j,im) = dabs (phiatf)
	    enddo
	   enddo
c
	  enddo
c
c  Ciclo di iterazioni sulla sorgente di scattering
c
        do iscat = 1,10000000
c
        call trasp
c
        call sscat
c
c  Controllo di convergenza sul flusso scalare 
c
        dphimx = 0.d00
c   
	  imax = 1
	  jmax = 1
	  kmax = 1 
c
 	   do i = 1,nx
	    do j = 1,ny
 	     do k = 1,nz
c
           absdif = dabs ( phi(i,j,k) - oldphi(i,j,k) )
c
		 if(dphimx.lt.absdif) then
		 dphimx = absdif
	     imax = i
	     jmax = j
		 kmax = k 
	     endif
c
	     enddo
	    enddo
	   enddo
c
        write(*,100) iscat,dphimx
	  write(*,*) imax,jmax,kmax
	  write(*,*) phi(imax,jmax,kmax),oldphi(imax,jmax,kmax)
        write(6,100) iscat,dphimx   
c
c   Criterio di fermata delle iterazioni sulla sezione di scattering
c
        if(dphimx.lt.epsphi) goto 10
c
c   Assegnazione del flusso alla vecchia iterazione
c
        do i = 1,nx
	   do j = 1,ny
 	    do k = 1,nz
c
	     oldphi(i,j,k) = phi(i,j,k)
c
	    enddo
	   enddo
	  enddo
c
        enddo
c
   10 continue
c
        nxh = nx / 2
        nyh = ny / 2
        nzh = nz / 2
c
c   Mappe relative ai piani z = zmax / 2 e z = 0
c
        do i = 1,nx
	   do j = 1,ny
c
          write(8,200) xm(i),ym(j),phi(i,j,nzh)
          write(11,200) xm(i),ym(j),phi(i,j,1)
          write(14,200) xm(i),ym(j),phi(i,j,nz)
c
	    enddo
	   enddo
c
c   Mappe relative ai piani y = ymax / 2 e y = 0
c
        do i = 1,nx
	   do k = 1,nz
c
          write(9,200) xm(i),zm(k),phi(i,nyh,k)
          write(12,200) xm(i),zm(k),phi(i,1,k)
          write(15,200) xm(i),zm(k),phi(i,ny,k)
c
	    enddo
	   enddo
c
c   Mappe relative ai piani x = xmax / 2 e x = 0
c
        do j = 1,ny
	   do k = 1,nz
c
          write(10,200) ym(j),zm(k),phi(nxh,j,k)
          write(13,200) ym(j),zm(k),phi(1,j,k)
          write(16,200) ym(j),zm(k),phi(nx,j,k)
c
	    enddo
	   enddo
c
      stop
  100 format(/,1x,' Iterazione sulla Sorgente di Scattering N. ',i6,
     &          ' Errphi = ',e14.7,/)
  200 format(3(1x,e14.7))
	end
c----------------------------------------------------------------------c
c                                                                      c
c    Subroutine per generare direzioni ammissibili nell'ottante        c
c    con coseni direttori positivi                                     c
c                                                                      c
c----------------------------------------------------------------------c
      subroutine diradm
      implicit double precision (a-h,o-z)
c
      include 'tras3dc.for'
c
c
c   Assegnazione delle ordinate discrete e dei relativi pesi
c
      nm = nordin * ( nordin + 2 )
      noct = nm / 8
c
c   Parametri per la quadratura LQ2
c
       if(nordin.eq.2) then
c
         rsqr3 = 1.d00 / dsqrt(3.d00)
c
         ami(1) = rsqr3   
         eta(1) = rsqr3
         zeta(1) = rsqr3
c
         w(1) = 1.d00	      
c
         call rotoct (1)
c
c   Parametri per la quadratura LQ4
c
       elseif(nordin.eq.4) then
c
         ami1 = 0.3500212d00
	   ami2 = dsqrt ( 1.d00 - 2.d00 * ami1 * ami1 )
c
         weight = 1.d00 / 3.d00
c
         ami(1) = ami1
         eta(1) = ami1
         zeta(1) = ami2
c
         w(1) = weight
c
         call rotoct (1)
c
c
         ami(2) = ami1
         eta(2) = ami2
         zeta(2) = ami1
c
         w(2) = weight
c
         call rotoct (2)
c
c
         ami(3) = ami2
         eta(3) = ami1
         zeta(3) = ami1
c
         w(3) = weight
c
         call rotoct (3)
c
c   Parametri per la quadratura LQ6
c
       elseif(nordin.eq.6) then
c
c
         ami1 = 0.2666355d00
c
         cost = 2.d00 * ( 1.d00 - 3.d00 * ami1 * ami1 ) 
     &                                  /  dfloat ( nordin - 2 )
	   ami2 = dsqrt ( ami1 * ami1 + cost )
c
	   ami3 = dsqrt ( ami1 * ami1 + 2.d00 * cost )
c
         weigh1 = 0.1761263d00
	   weigh2 = ( 1.d00 - 3.d00 * weigh1 ) / 3.d00
c
c
         ami(1) = ami1
         eta(1) = ami1
         zeta(1) = ami3
c
         w(1) = weigh1
c
         call rotoct (1)
c
c
         ami(2) = ami1
         eta(2) = ami3
         zeta(2) = ami1
c
         w(2) = weigh1
c
         call rotoct (2)
c
c
         ami(3) = ami3
         eta(3) = ami1
         zeta(3) = ami1
c
         w(3) = weigh1
c
         call rotoct (3)
c
c
         ami(4) = ami2
         eta(4) = ami2
         zeta(4) = ami1
c
         w(4) = weigh2
c
         call rotoct (4)
c
c
         ami(5) = ami2
         eta(5) = ami1
         zeta(5) = ami2
c
         w(5) = weigh2
c
         call rotoct (5)
c
c
         ami(6) = ami1
         eta(6) = ami2
         zeta(6) = ami2
c
         w(6) = weigh2
c
         call rotoct (6)
c
c   Parametri per la quadratura LQ8
c
       elseif(nordin.eq.8) then
c
c
         ami1 = 0.2182179d00
c
         cost = 2.d00 * ( 1.d00 - 3.d00 * ami1 * ami1 ) 
     &                                  /  dfloat ( nordin - 2 )
	   ami2 = dsqrt ( ami1 * ami1 + cost )
c
	   ami3 = dsqrt ( ami1 * ami1 + 2.d00 * cost )
c
	   ami4 = dsqrt ( ami1 * ami1 + 3.d00 * cost )
c
         weigh1 = 0.1209877d00
	   weigh2 = 0.0907407d00
	   weigh3 = ( 1.d00 - 3.d00 * weigh1 - 6.d00 * weigh2 ) 
c
c
         ami(1) = ami1
         eta(1) = ami1
         zeta(1) = ami4
c
         w(1) = weigh1
c
         call rotoct (1)
c
c
         ami(2) = ami1
         eta(2) = ami4
         zeta(2) = ami1
c
         w(2) = weigh1
c
         call rotoct (2)
c
c
         ami(3) = ami4
         eta(3) = ami1
         zeta(3) = ami1
c
         w(3) = weigh1
c
         call rotoct (3)
c
c
         ami(4) = ami1
         eta(4) = ami2
         zeta(4) = ami3
c
         w(4) = weigh2
c
         call rotoct (4)
c
c
         ami(5) = ami2
         eta(5) = ami1
         zeta(5) = ami3
c
         w(5) = weigh2
c
         call rotoct (5)
c
c
         ami(6) = ami1
         eta(6) = ami3
         zeta(6) = ami2
c
         w(6) = weigh2
c
         call rotoct (6)
c
c
         ami(7) = ami2
         eta(7) = ami3
         zeta(7) = ami1
c
         w(7) = weigh2
c
         call rotoct (7)
c
c
         ami(8) = ami3
         eta(8) = ami1
         zeta(8) = ami2
c
         w(8) = weigh2
c
         call rotoct (8)
c
c
         ami(9) = ami3
         eta(9) = ami2
         zeta(9) = ami1
c
         w(9) = weigh2
c
         call rotoct (9)
c
c
         ami(10) = ami2
         eta(10) = ami2
         zeta(10) = ami2
c
         w(10) = weigh3
c
         call rotoct (10)
c
	 endif
c
      do im = 1,nm
c
c   Assegnazione delle direzioni corrispondenti tramite la riflessione 
c   sui piani coordinati
c
         do imr = 1,nm
           if ( (ami(imr).eq.-ami(im)).and.(eta(imr).eq.eta(im))
     &            .and.(zeta(imr).eq.zeta(im)) ) irx(im) = imr 
           if ( (ami(imr).eq.ami(im)).and.(eta(imr).eq.-eta(im))
     &            .and.(zeta(imr).eq.zeta(im)) ) iry(im) = imr 
           if ( (ami(imr).eq.ami(im)).and.(eta(imr).eq.eta(im))
     &            .and.(zeta(imr).eq.-zeta(im)) ) irz(im) = imr 

	   enddo
c
c   Check sulla normalizzazione dei coseni direttori
c
      check = ami(im)*ami(im) + eta(im)*eta(im) + zeta(im)*zeta(im)
c
      write(7,100) im,ami(im),eta(im),zeta(im),w(im),check
c
      enddo
c
      return
  100 format(1x,i5,5(1x,e14.7))
      end
c----------------------------------------------------------------------c
c                                                                      c
c    Subroutine per generare direzioni ammissibili nei 7 ottanti       c
c    con coseni direttori negativi                                     c
c                                                                      c
c----------------------------------------------------------------------c
      subroutine rotoct (i)
      implicit double precision (a-h,o-z)
c
      include 'tras3dc.for'
c
      im = i + noct        
c
c   ami < 0 , eta > 0 , zeta > 0
c
      w(im) = w(i)
c
      ami(im) = - eta(i)
	eta(im) = ami(i)
	zeta(im) = zeta(i)
c
c   ami < 0 , eta < 0 , zeta > 0
c
      im = i + noct * 2       
c
      w(im) = w(i)
c
      ami(im) = - ami(i)
	eta(im) = - eta(i)
	zeta(im) = zeta(i)
c
c   ami > 0 , eta < 0 , zeta > 0
c
      im = i + noct * 3       
c
      w(im) = w(i)
c
      ami(im) = eta(i)
	eta(im) = - ami(i)
	zeta(im) = zeta(i)
c
c   ami > 0 , eta > 0 , zeta < 0
c
      im = i + noct * 4       
c
      w(im) = w(i)
c
      ami(im) = ami(i)
	eta(im) = eta(i)
	zeta(im) = - zeta(i)
c
c   ami < 0 , eta > 0 , zeta < 0
c
      im = i + noct * 5       
c
      w(im) = w(i)
c
      ami(im) = - eta(i)
	eta(im) = ami(i)
	zeta(im) = - zeta(i)
c
c   ami < 0 , eta < 0 , zeta < 0
c
      im = i + noct * 6       
c
      w(im) = w(i)
c
      ami(im) = - ami(i)
	eta(im) = - eta(i)
	zeta(im) = - zeta(i)
c
c   ami > 0 , eta < 0 , zeta < 0
c
      im = i + noct * 7       
c
      w(im) = w(i)
c
      ami(im) = eta(i)
	eta(im) = - ami(i)
	zeta(im) = - zeta(i)
c
      return
	end
c----------------------------------------------------------------------c
c                                                                      c
c    Subroutine per la soluzione delle equazioni 3D del trasporto      c
c                                                                      c
c----------------------------------------------------------------------c
      subroutine trasp
      implicit double precision (a-h,o-z)
c
      include 'tras3dc.for'
c
c   Azzeramento del flusso scalare
c
       do i = 1,nx
	  do j = 1,ny
	   do k = 1,nz
c
         phi(i,j,k) = 0.d00
c	   	         
         enddo
	  enddo
	 enddo
c
c  Ciclo sull'indice delle direzioni ammissibili
c
      do im = 1,nm
c
      write(*,100) im
      write(6,100) im
  100 format(1x,' Processamento della direzione ',i6)
c
c  Discussione del segno dei coseni direttori e imposizione delle
c  condizioni al contorno: flusso imposto o riflessione
c
c
c  Condizioni lungo l'asse x
c     
       if(ami(im).gt.0.d00) then
	 i1 = 1
       i2 = nx
	 ist = 1
c
        do j = 1,ny
	   do k = 1,nz
	      if(phiawf.ge.0.d00) then
            phiax(1,j,k) = phiawf
	      else
            phiax(1,j,k) = phiawm(j,k,irx(im))
	      endif
         enddo
	  enddo
c
	 else
	 i1 = nx
       i2 = 1
	 ist = - 1
c
        do j = 1,ny
	   do k = 1,nz
	      if(phiaef.ge.0.d00) then
            phiax(nx+1,j,k) = phiaef
	      else
            phiax(nx+1,j,k) = phiaem(j,k,irx(im))
            endif
         enddo
	  enddo
c
       endif
c
c  Condizioni lungo l'asse y
c     

       if(eta(im).gt.0.d00) then
	 j1 = 1
       j2 = ny
	 jst = 1
c
        do i = 1,nx
	   do k = 1,nz
	      if(phiasf.ge.0.d00) then
            phiay(i,1,k) = phiasf
	      else
            phiay(i,1,k) = phiasm(i,k,iry(im))
	      endif
         enddo
	  enddo
c
	 else
	 j1 = ny
       j2 = 1
	 jst = - 1
c
        do i = 1,nx
	   do k = 1,nz
	      if(phianf.ge.0.d00) then
            phiay(i,ny+1,k) = phianf
	      else
            phiay(i,ny+1,k) = phianm(i,k,iry(im))
	      endif
         enddo
	  enddo
c
       endif
c
c  Condizioni lungo l'asse z
c     
       if(zeta(im).gt.0.d00) then
	 k1 = 1
       k2 = nz
	 kst = 1
c
        do i = 1,nx
	   do j = 1,ny
	      if(phiabf.ge.0.d00) then
            phiaz(i,j,1) = phiabf
	      else
	      phiaz(i,j,1) = phiabm(i,j,irz(im))
	      endif
         enddo
	  enddo
c
	 else
	 k1 = nz
       k2 = 1
	 kst = - 1
c
        do i = 1,nx
	   do j = 1,ny
	      if(phiatf.ge.0.d00) then
            phiaz(i,j,nz+1) = phiatf
	      else
            phiaz(i,j,nz+1) = phiatm(i,j,irz(im))
	      endif
         enddo
	  enddo
c
       endif
c
c  Soluzione delle equazioni di bilancio neutronico
c  spazzando i tre assi secondo il segno dei coseni direttori
c
        do i = i1,i2,ist
        dx = x(i+1) - x(i)
	  auxx = 2.d00 * dabs(ami(im)) / dx
c
         do j = j1,j2,jst
         dy = y(j+1) - y(j)
         auxy = 2.d00 * dabs(eta(im)) / dy
c
          do k = k1,k2,kst
          dz = z(k+1) - z(k)
          auxz = 2.d00 * dabs(zeta(im)) / dz
c
c  Preparazione del valore di alcuni addendi utili
c         
          if(ist.eq.1) then
		addx = auxx * phiax(i,j,k)
	    else
		addx = auxx * phiax(i+1,j,k)
	    endif
c         
          if(jst.eq.1) then
		addy = auxy * phiay(i,j,k)
	    else
		addy = auxy * phiay(i,j+1,k)
	    endif
c         
          if(kst.eq.1) then
		addz = auxz * phiaz(i,j,k)
	    else
		addz = auxz * phiaz(i,j,k+1)
	    endif
c
c   Valutazione del flusso centrale tramite il bilancio neutronico
c
          ifixx = 0
          ifixy = 0
          ifixz = 0
c
   20     denom = auxx + auxy + auxz + sigt(i,j,k)
c
          phiac(i,j,k) = ( addx + addy + addz + q(i,j,k) ) / denom 
c
c   Applicazione della regola del diamante per valutare i flussi di interfaccia
c   secondo il segno dei coseni direttori; nel caso di flussi di interfaccia negativi
c   si opera un fix-up con la regola dello "step" e si ricalcola il flusso centrale
c   per garantire che il bilancio neutronico sia preservato
c         
          if(ist.eq.1) then
c
		  if(ifixx.eq.0) then
            phiax(i+1,j,k) = 2.d00 * phiac(i,j,k) - phiax(i,j,k)
	      else
            phiax(i+1,j,k) = phiac(i,j,k)
	      endif
c
	         if(phiax(i+1,j,k).lt.0.d00) then
         	     auxx = dabs(ami(im)) / dx
			 addx = auxx * phiax(i,j,k)
	         ifixx = ifixx + 1
c	         write(*,111) im,i,j,k
c	         write(6,111) im,i,j,k
  111          format(1x,' Fix-up lungo x: direzione ',i5,' nodo ',3i6)
	         goto 20
	         endif
c
	    else
c
		  if(ifixx.eq.0) then
            phiax(i,j,k) = 2.d00 * phiac(i,j,k) - phiax(i+1,j,k)
	      else
            phiax(i,j,k) = phiac(i,j,k)
	      endif
c
	         if(phiax(i,j,k).lt.0.d00) then
         	     auxx = dabs(ami(im)) / dx
			 addx = auxx * phiax(i+1,j,k)
	         ifixx = ifixx + 1
c	         write(*,111) im,i,j,k
c	         write(6,111) im,i,j,k
	         goto 20
	         endif
c
	    endif
c         
          if(jst.eq.1) then
c
		  if(ifixy.eq.0) then
            phiay(i,j+1,k) = 2.d00 * phiac(i,j,k) - phiay(i,j,k)
	      else
            phiay(i,j+1,k) = phiac(i,j,k)
	      endif
c
	         if(phiay(i,j+1,k).lt.0.d00) then
         	     auxy = dabs(eta(im)) / dy
			 addy = auxy * phiay(i,j,k)
	         ifixy = ifixy + 1
c	         write(*,112) im,i,j,k
c	         write(6,112) im,i,j,k
  112          format(1x,' Fix-up lungo y: direzione ',i5,' nodo ',3i6)
	         goto 20
	         endif
c
	    else
c
		  if(ifixy.eq.0) then
            phiay(i,j,k) = 2.d00 * phiac(i,j,k) - phiay(i,j+1,k)
	      else
            phiay(i,j,k) = phiac(i,j,k)
	      endif
c
	         if(phiay(i,j,k).lt.0.d00) then
         	     auxy = dabs(eta(im)) / dy
			 addy = auxy * phiay(i,j+1,k)
	         ifixy = ifixy + 1
c	         write(*,112) im,i,j,k
c	         write(6,112) im,i,j,k
  	         goto 20
	         endif
c
 	    endif
c         
          if(kst.eq.1) then
c
		  if(ifixz.eq.0) then
            phiaz(i,j,k+1) = 2.d00 * phiac(i,j,k) - phiaz(i,j,k)
	      else
            phiaz(i,j,k+1) = phiac(i,j,k)
	      endif
c
	         if(phiaz(i,j,k+1).lt.0.d00) then
         	     auxz = dabs(zeta(im)) / dz
			 addz = auxz * phiaz(i,j,k)
	         ifixz = ifixz + 1
c	         write(*,113) im,i,j,k
c	         write(6,113) im,i,j,k
  113          format(1x,' Fix-up lungo z: direzione ',i5,' nodo ',3i6)
	         goto 20
	         endif
	    else
c
		  if(ifixz.eq.0) then
            phiaz(i,j,k) = 2.d00 * phiac(i,j,k) - phiaz(i,j,k+1)
	      else
            phiaz(i,j,k) = phiac(i,j,k)
	      endif
c
	         if(phiaz(i,j,k).lt.0.d00) then
         	     auxz = dabs(zeta(im)) / dz
			 addz = auxz * phiaz(i,j,k+1)
	         ifixz = ifixz + 1
c	         write(*,113) im,i,j,k
c	         write(6,113) im,i,j,k
	         goto 20
	         endif
c
	    endif
c
c   Assegnazione del contributo al flusso scalare
c         
         phi(i,j,k) = phi(i,j,k) + 0.125d00 * phiac(i,j,k) * w(im)
c
c   Assegnazione del flusso angolare sulle superfici laterali 
c   per poter imporre condizioni al contorno di riflessione pura
c
           if(i.eq.1) then   
           phiawm(j,k,im) = phiax(i,j,k)
	     elseif(i.eq.nx) then
		 phiaem(j,k,im) = phiax(nx+1,j,k)
		 endif
c		  
           if(j.eq.1) then   
           phiasm(i,k,im) = phiay(i,j,k)
	     elseif(j.eq.ny) then
		 phianm(i,k,im) = phiay(i,ny+1,k)
		 endif
c		  
           if(k.eq.1) then   
           phiabm(i,j,im) = phiaz(i,j,k)
	     elseif(k.eq.nz) then
		 phiatm(i,j,im) = phiaz(i,j,nz+1)
		 endif
c		  
         enddo
c
        enddo
c
       enddo
c
      enddo
c
      return
	end
c----------------------------------------------------------------------c
c                                                                      c
c    Subroutine per l'aggiornamento della densit di emissione sulla   c
c    della nuova sorgente di scattering                                c
c                                                                      c
c----------------------------------------------------------------------c
      subroutine sscat
      implicit double precision (a-h,o-z)
c
      include 'tras3dc.for'
c
c  Assegnazione del valore della densit di emissione
c
        do i = 1,nx
	   do j = 1,ny
 	    do k = 1,nz
	     q(i,j,k) = sour(i,j,k) + sigs(i,j,k) * phi(i,j,k)
c
	    enddo
	   enddo
	  enddo
c
      return
	end